
package net.mcreator.bloonsballoons.entity;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.network.PlayMessages;
import net.minecraftforge.network.NetworkHooks;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.monster.RangedAttackMob;
import net.minecraft.world.entity.ai.goal.target.NearestAttackableTargetGoal;
import net.minecraft.world.entity.ai.goal.RangedAttackGoal;
import net.minecraft.world.entity.ai.goal.RandomLookAroundGoal;
import net.minecraft.world.entity.ai.goal.MeleeAttackGoal;
import net.minecraft.world.entity.ai.attributes.Attributes;
import net.minecraft.world.entity.ai.attributes.AttributeSupplier;
import net.minecraft.world.entity.PathfinderMob;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.protocol.Packet;
import net.minecraft.network.chat.TextComponent;

import net.mcreator.bloonsballoons.init.BloonsBalloonsModItems;
import net.mcreator.bloonsballoons.init.BloonsBalloonsModEntities;

public class Dmup1Entity extends PathfinderMob implements RangedAttackMob {
	public Dmup1Entity(PlayMessages.SpawnEntity packet, Level world) {
		this(BloonsBalloonsModEntities.DMUP_1.get(), world);
	}

	public Dmup1Entity(EntityType<Dmup1Entity> type, Level world) {
		super(type, world);
		xpReward = 0;
		setNoAi(false);
		setCustomName(new TextComponent("Teir 1"));
		setCustomNameVisible(true);
		setPersistenceRequired();
	}

	@Override
	public Packet<?> getAddEntityPacket() {
		return NetworkHooks.getEntitySpawningPacket(this);
	}

	@Override
	protected void registerGoals() {
		super.registerGoals();
		this.targetSelector.addGoal(1, new NearestAttackableTargetGoal(this, MoabEntity.class, true, true));
		this.targetSelector.addGoal(2, new NearestAttackableTargetGoal(this, BFBEntity.class, true, true));
		this.targetSelector.addGoal(3, new NearestAttackableTargetGoal(this, ZomgEntity.class, true, true));
		this.targetSelector.addGoal(4, new NearestAttackableTargetGoal(this, BedEntity.class, true, true));
		this.targetSelector.addGoal(5, new NearestAttackableTargetGoal(this, CeramicbloonEntity.class, true, true));
		this.targetSelector.addGoal(6, new NearestAttackableTargetGoal(this, LeadBloonEntity.class, true, true));
		this.targetSelector.addGoal(7, new NearestAttackableTargetGoal(this, RainbloonEntity.class, true, true));
		this.targetSelector.addGoal(8, new NearestAttackableTargetGoal(this, ZebloonEntity.class, true, true));
		this.targetSelector.addGoal(9, new NearestAttackableTargetGoal(this, BlackbEntity.class, true, true));
		this.targetSelector.addGoal(10, new NearestAttackableTargetGoal(this, WhitebEntity.class, true, true));
		this.targetSelector.addGoal(11, new NearestAttackableTargetGoal(this, PinkbEntity.class, true, true));
		this.targetSelector.addGoal(12, new NearestAttackableTargetGoal(this, YellbEntity.class, true, true));
		this.targetSelector.addGoal(13, new NearestAttackableTargetGoal(this, GreenbEntity.class, true, true));
		this.targetSelector.addGoal(14, new NearestAttackableTargetGoal(this, BluebEntity.class, true, true));
		this.targetSelector.addGoal(15, new NearestAttackableTargetGoal(this, RbloonEntity.class, true, true));
		this.goalSelector.addGoal(16, new MeleeAttackGoal(this, 0, false) {
			@Override
			protected double getAttackReachSqr(LivingEntity entity) {
				return (double) (4.0 + entity.getBbWidth() * entity.getBbWidth());
			}
		});
		this.goalSelector.addGoal(17, new RandomLookAroundGoal(this));
		this.goalSelector.addGoal(1, new RangedAttackGoal(this, 1.25, 20, 10) {
			@Override
			public boolean canContinueToUse() {
				return this.canUse();
			}
		});
	}

	@Override
	public MobType getMobType() {
		return MobType.UNDEFINED;
	}

	@Override
	public boolean removeWhenFarAway(double distanceToClosestPlayer) {
		return false;
	}

	protected void dropCustomDeathLoot(DamageSource source, int looting, boolean recentlyHitIn) {
		super.dropCustomDeathLoot(source, looting, recentlyHitIn);
		this.spawnAtLocation(new ItemStack(BloonsBalloonsModItems.DMT_1.get()));
	}

	@Override
	public SoundEvent getHurtSound(DamageSource ds) {
		return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
	}

	@Override
	public SoundEvent getDeathSound() {
		return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
	}

	@Override
	public boolean hurt(DamageSource source, float amount) {
		if (source.getDirectEntity() instanceof AbstractArrow)
			return false;
		if (source == DamageSource.FALL)
			return false;
		if (source.isExplosion())
			return false;
		return super.hurt(source, amount);
	}

	@Override
	public void performRangedAttack(LivingEntity target, float flval) {
		Dartt1Entity.shoot(this, target);
	}

	public static void init() {
	}

	public static AttributeSupplier.Builder createAttributes() {
		AttributeSupplier.Builder builder = Mob.createMobAttributes();
		builder = builder.add(Attributes.MOVEMENT_SPEED, 0);
		builder = builder.add(Attributes.MAX_HEALTH, 1);
		builder = builder.add(Attributes.ARMOR, 0);
		builder = builder.add(Attributes.ATTACK_DAMAGE, 3);
		builder = builder.add(Attributes.FOLLOW_RANGE, 26);
		builder = builder.add(Attributes.KNOCKBACK_RESISTANCE, 1000);
		return builder;
	}
}
